class Ant {
    public var x:Int;
    public var y:Int;
    public var mapHeight:Int;
    public var mapWidth:Int;
    public var rotation:Rotation;

    public function new(mapWidth:Int, mapHeight:Int) {
        this.mapWidth = mapWidth;
        this.mapHeight = mapHeight;

        x = mapWidth >> 1;
        y = mapHeight >> 1;
        rotation = Up;
    }

    public function rotRight() {
        rotation = switch (rotation) {
            case Up: Right;
            case Right: Down;
            case Down: Left;
            case Left: Up;
        }
    }

    public function rotLeft() {
        rotation = switch (rotation) {
            case Up: Left;
            case Left: Down;
            case Down: Right;
            case Right: Up;
        }
    }

    public function move() {
        switch (rotation) {
            case Up:
                y++;
            case Right:
                x++;
            case Down:
                y--;
            case Left:
                x--;
        }

        if (y > mapHeight - 1)
            y = 0;
        if (y < 0)
            y = mapHeight - 1;

        if (x > mapWidth - 1)
            x = 0;
        if (x < 0)
            x = mapWidth - 1;
    }
}

enum Rotation {
    Up;
    Right;
    Down;
    Left;
}
