import tink.color.Color;
import h2d.Tile;
import h2d.Bitmap;
import hxd.BitmapData;
import hxd.Window;

using StringTools;

class Main extends hxd.App {
    var map:BitmapData;
    var ant:Ant;
    var tile:Tile;
    var bitmap:Bitmap;
    var hue:Float;

    override function init() {
        Window.getInstance().title = "rainbowant";
        map = new BitmapData(s2d.width, s2d.height);
        ant = new Ant(s2d.width, s2d.height);
        bitmap = new Bitmap(tile = Tile.fromBitmap(map), s2d);
        hue = 0;
    }

    override function onResize() {
        map.dispose();
        bitmap.remove();

        ant = new Ant(s2d.width, s2d.height);
        map = new BitmapData(s2d.width, s2d.height);
        map.fill(0, 0, s2d.width, s2d.height, 0xFF000000);
        bitmap = new Bitmap(tile = Tile.fromBitmap(map), s2d);
        hue = 0;
    }

    override function update(dt:Float) {
        var color = Color.hsv(hue, 1, 1);
        map.lock();
        for (_ in 0...10000) {
            if (map.getPixel(ant.x, ant.y) == 0) {
                map.setPixel(ant.x, ant.y, cast(color, Int));

                ant.rotRight();
                ant.move();
            } else {
                map.setPixel(ant.x, ant.y, 0);

                ant.rotLeft();
                ant.move();
            }

            hue = (hue + 0.0001) % 360;
        }
        map.unlock();

        tile.getTexture().uploadPixels(map.getPixels());
    }

    static function main() {
        new Main();
    }
}
